#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "gun2two4xi.py">
#<abstract4xi abstract = "guns to direction two"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'gun2two4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from dummyprocess4xi import DummyProcess4Xi

from shoot2two4xi import shoot2two4xi

from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

      
#"
#"/>
    
             
# -----------------------------------------------------------------------------------------------------
#<function4xi function = "gun2two4xi" usage = "
#   gun for Process4Xi-2
#"> 
# -----------------------------------------------------------------------------------------------------
       
def gun2two4xi(queue2work, channel2consume, channel2publish):
    '''
    guns for Process4Xi-2
    '''    
        
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    print('=' *33)
    print("(STEP 1/33) OF GUN2TWO4XI, START TIME: ", time4xi()) 
    print('=' *33)
    # 10:58:41 04/21/13 Pacific Daylight Time
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    queue2work4two = queue2work
    
    print('~' *33)
    print("(STEP 2/33) OF GUN2TWO4XI, QUEUE2WORK4TWO: ", queue2work4two)
    print('~' *33)
    # <queue4xi.Queue4Xi object at 0x0000000006518208>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    channel2consume4two = channel2consume
    print('~' *33)
    print("(STEP 3/33) OF GUN2TWO4XI, CHANNEL2CONSUME4TWO: ", channel2consume4two)
    print('~' *33)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000064CD438>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    channel2publish4two = channel2publish
    print('~' *33)
    print("(STEP 4/33) OF GUN2TWO4XI, CHANNEL2PUBLISH4TWO: ", channel2publish4two)
    print('~' *33)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000064CDC18>
        
    
    # ---------------------------------------------------------------------------------------------    
    # GETTING FROM QUEUE
    # --------------------------------------------------------------------------------------------- 
        
    try:
        message2qet4two = queue2work4two.get()
        print("(STEP 5A/33) OF GUN2TWO4XI - MESSAGE2QET4TWO GOT: ", message2qet4two) 
        # <copy4xi>copy2two</copy4xi>
        
        if message2qet4two == "<copy4xi>copy2two</copy4xi>":
            message2put4two = "<roger4xi>roger2two</roger4xi>"
            print("(STEP 5B/33) OF GUN2TWO4XI - SET MESSAGE2PUT4TWO TO: ", message2put4two) 
            # <roger4xi>roger2two</roger4xi>
        else:
            print("(STEP 5c/33) OF GUN2TWO4XI - *** UNREGONIZED MESSAGE GOT: ", message2qet4two)           
            message2put4two = "<negative4xi>negative2two</negative4xi>"
            print("(STEP 5d/33) OF GUN2TWO4XI - SET MESSAGE2PUT4TWO TO: ", message2put4two)             
    except:
        message2put4two = "<negative4xi>negative2two</negative4xi>"
    
    
    # ---------------------------------------------------------------------------------------------    
    # PUTTING TO QUEUE
    # --------------------------------------------------------------------------------------------- 
    print("(STEP 6A/33) OF GUN2TWO4XI - TRYING TO PUT MESSAGE2PUT4TWO: ", message2put4two)                                  
    try:         
        queue2work4two.put(message2put4two) 
        print('~' *33)
        print("(STEP 6B/33) OF GUN2TWO4XI - PUT TO QUEUE2WORK4TWO: ", queue2work4two, ' MESSAGE2PUT4TWO: ', message2put4two)
        print('~' *33)
        # <queue4xi.Queue4Xi object at 0x02DA22F0>  MESSAGE2PUT4TWO:  <roger4xi>roger2two</roger4xi>
        
    except:
        print("(STEP 6c/33) OF GUN2TWO4XI *** FAILED TO PUT TO QUEUE2WORK4TWO: ", queue2work4two, ' MESSAGE2PUT4TWO: ', message2put4two)
                   
    # ---------------------------------------------------------------------------------------------    
    # RECEIVING FROM PIPE CONSUMER CHANNEL
    # ---------------------------------------------------------------------------------------------     

    print("(STEP 7A/33) OF GUN2TWO4XI - TRYING TO RECEIVE FROM CHANNEL2CONSUME4TWO: ", channel2consume4two)
    try:
        message2receive4two = channel2consume4two.recv()
        print("(STEP 7B/33) OF GUN2TWO4XI - RECEIVED MESSAGE2RECEIVE4TWO: ", message2receive4two)
        # <copy4xi>copy2two</copy4xi>
        
        if message2receive4two == "<copy4xi>copy2two</copy4xi>":
            message2send4two = "<roger4xi>roger2two</roger4xi>"
            print("(STEP 7C/33) OF GUN2TWO4XI - SET MESSAGE2SEND4TWO: ", message2send4two)
            # <roger4xi>roger2two</roger4xi>
        else:
            message2send4two = "<negative4xi>negative2two</negative4xi>"
            print("(STEP 7D/33) OF GUN2TWO4XI - SET MESSAGE2SEND4TWO: ", message2send4two)        
    except:
        print("(STEP 7E/33) OF GUN2TWO4XI - *** EXCEPTION WITH CHANNEL2CONSUME4TWO.RECV: ", channel2consume4two.recv) 
        message2send4two = "<negative4xi>negative2two</negative4xi>"
        print("(STEP 7F/33) OF GUN2TWO4XI - SET MESSAGE2SEND4TWO: ", message2send4two)       
            
        
            
    # ---------------------------------------------------------------------------------------------
    # SEND DATA TO THE PIPE'S PUBLISHER CHANNEL 
    # ---------------------------------------------------------------------------------------------
    print("(STEP 8A/33) OF GUN2TWO4XI - TRYING TO SEND DATA TO CHANNEL2PUBLISHER4TWO: ", channel2publish4two)
    # 
    try:         
        channel2publish4two.send(message2send4two)
        print("(STEP 8B/33) OF GUN2TWO4XI - SENT MESSAGE2SEND4TWO: ", message2send4two, " CHANNEL2PUBLISHER4TWO: ", channel2publish4two)
        # <roger4xi>roger2two</roger4xi>  CHANNEL2PUBLISHER4TWO:  <read-write PipeConnection, handle 252>
    except:
        print("(STEP 8C/33) OF GUN2TWO4XI - *** FAILED TO SEND MESSAGE2SEND4TWO: ", message2send4two, " CHANNEL2PUBLISHER4TWO: ", channel2publish4two) 
    
    # ---------------------------------------------------------------------------------------------    
    # PERFORMING MANOEUVRE 
    # --------------------------------------------------------------------------------------------- 
    print("(STEP 9A/33) OF GUN2TWO4XI - TRYING MANOEUVRE SPHERE2ENB: (+X,-Y,-Z) - EAST, NORTH, BACKWARDS")     
    
    
    ack2function = False
    if ack2function is True:
        # -----------------------------------------------------------------------------------------    
        # Using the function to shoot - this approach works, but blocks return to MainProcess4Xi! 
        # -----------------------------------------------------------------------------------------     
        try: 
            sphere2enb = shoot2two4xi(start2distance = 100, interval2distance = 100, max2layer = 100, max2count = 200, marginal2count = 1.2, sign2x = '+', sign2y = '-', sign2z = '-',
                                      max2iterate = 4200, increase2distance = None, change2a = pi/60 , change2e = pi/60, increase2a = 0.01, increase2e = 0.01,
                                      start2plusa = 0.5759586531581287, max2plusa = 2*pi, min2plusa = pi/240, start2minusa = -pi/6 , max2minusa = -0.98*2*pi, min2minusa = -pi/240,
                                      start2pluse = 0.5335987755982988, max2pluse = pi, min2pluse = pi/240, start2minuse = -pi/6, max2minuse = -0.98*pi, min2minuse = -pi/240)                    
                   
            print("(STEP 9B/33) OF GUN2TWO4XI - PERFORMED MANOEUVRE SPHERE2ENB: (+X,-Y,-Z) - EAST, NORTH, BACKWARDS")     
            # for results search (STEP 32/33) OF SHOOT2TWO4XI - STATISTICS FOR REQUIRED           
        except:
            print("(STEP 9C/33) OF GUN2TWO4XI *** FAILED TO PERFORM MANOEUVRE SPHERE2ENB: (+X,-Y,-Z) - EAST, NORTH, BACKWARDS")          
    else:
        pass
    
    ack2process = True
    if ((ack2process is True) and (ack2function is False)):
        # -----------------------------------------------------------------------------------------    
        # Using the dummy process to shoot - this approach tries faster return to MainProcess4Xi  
        # -----------------------------------------------------------------------------------------      
        print("(STEP 10A/33) OF GUN2TWO4XI - CREATING A DUMMY PROCESS4XI")  
        ack2dummy = False
        
        # -----------------------------------------------------------------------------------------    
        # create the dummy process object 
        # -----------------------------------------------------------------------------------------          
        # to be checked in test_sphere4xi.txt: OK SHOOTING OF SHOOT2TWO4XI
        # example: ACCEPTED SHOTS  106  >=  80  ORIGINALLY REQUIRED, MARIGINAL:  1.2
        try:                            # latest ok shot
            start2distance = 10         # 3300
            interval2distance = 10      # 100 
            max2layer = 10              # 100 
            marginal2layer = 1.2        # 1.2
            max2count = 80              # 100    
      
            marginal2count = 1.2
            sign2x = '+'
            sign2y = '-'
            sign2z = '-'
            max2iterate = 2400
            
            start2plusa = 0.5759586531581287
            max2plusa = 2*pi
            min2plusa = pi/240
            start2minusa = -pi/6
            max2minusa = -0.98*2*pi
            min2minusa = -pi/240
            
            start2pluse = 0.5335987755982988
            max2pluse = pi
            min2pluse = pi/240
            start2minuse = -pi/6
            max2minuse = -0.98*pi
            min2minuse = -pi/240
            
            increase2distance = 1
            change2a = pi/60
            change2e = pi/60
            increase2a = 0.01
            increase2e = 0.01        
                    
            dummy2two = DummyProcess4Xi(target=shoot2two4xi, 
                                            args =(queue2work4two,
                                                   channel2consume4two, channel2publish4two,
                                                   start2distance, interval2distance, max2layer, marginal2layer,max2count,
                                                   marginal2count, sign2x, sign2y, sign2z, max2iterate, 
                                                   start2plusa, max2plusa, min2plusa, start2minusa, max2minusa, min2minusa,
                                                   start2pluse, max2pluse, min2pluse, start2minuse, max2minuse, min2minuse,
                                                   increase2distance, change2a, change2e, increase2a, increase2e))
                              
            print("(STEP 10B/33) OF GUN2TWO4XI - CREATED DUMMY_PROCESS4XI OBJECT DUMMY2TWO: ", dummy2two)
            # <DummyProcess4Xi(Thread-2, initial)> 
            
            ack2dummy = True
        except:
            print("(STEP 10C/33) OF GUN2TWO4XI *** FAILED TO CREATE DUMMY_PROCESS4XI OBJECT DUMMY2TWO ***")
            ack2dummy = False
            
        # -----------------------------------------------------------------------------------------    
        # start the dummy process object
        # -----------------------------------------------------------------------------------------              
        if ack2dummy is True:
            print("(STEP 10D/33) OF GUN2TWO4XI - STARTING THE DUMMY PROCESS4XI TIME: ", time4xi())  
            ack2start = False
            try:      
                dummy2two.start() 
                print("(STEP 10E/33) OF GUN2TWO4XI - STARTED THE DUMMY PROCESS4XI DUMMY2TWO: ", dummy2two)

                ack2start = True
            except:
                print("(STEP 10F/33) OF GUN2TWO4XI *** FAILED TO START THE DUMMY PROCESS4XI ***")
        else:
            print("(STEP 10G/33) OF GUN2TWO4XI ** YIELDED STARTING THE DUMMY PROCESS4XI - ACK2DUMMY: ", ack2dummy)
            ack2start = False 
    else:
        print("(STEP 10H/33) OF GUN2TWO4XI ** YIELDED STARTING THE DUMMY PROCESS4XI - ACK2DUMMY: ", ack2dummy, " ACK2FUNCTION: ", ack2function)
                                
                                       
                
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    print('=' *33)
    print("(STEP 11/33) OF GUN2TWO4XI - RETURNING TIME: ", time4xi())
    print('=' *33)
    # 
    
#</function4xi>
#</program4xi>             
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_sphere4xi.txt
#   sense-test-sphere4xi.xml
#   reason-test-sphere4xi.xml
#   ace-test-sphere4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of gun2two4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
